//
//  PalmDB.h
//  PdbViewer
//
//  Created by Daniel Braun on 04/03/05.
//  Copyright __MyCompanyName__ 2005 . All rights reserved.
//


#import <Cocoa/Cocoa.h>
#import "PdbRecord.h"

@interface PalmDB : NSObject
{
	NSString 	*name;
	unsigned short  attr;
	unsigned short  version;
	unsigned long 	modNumber;
	unsigned long	typeId;
	// all dates store internally as unix time
	// access as NSDate via accessor
	// unixDate states if date is read / should be record
	// as a palm date instead (starting at 1905).
	BOOL		unixDate;
	unsigned long	creatorId;
	unsigned long	creationDate;
	unsigned long	modificationDate;
	unsigned long	backupDate;
	NSMutableArray	*records;

	unsigned long 	appInfoOffset;
	unsigned long 	sortInfoOffset;
	unsigned long 	uniqId;
	unsigned long 	nextRecordList;
	unsigned short 	recCount;
}

- (NSString *) typeId;
- (void) setTypeId:(NSString *) fourCharString;

- (NSString *) creatorId;
- (void) setCreatorId:(NSString *) fourCharString;

- (unsigned long) intCreatorId;
- (void) setIntCreatorId: (unsigned long)v;

- (NSString *) name;
- (void) setName: (NSString *)aName;

- (unsigned short) version;
- (void) setVersion:(unsigned short) v;

- (NSDate *) creationDate;
- (void) setCreationDate:(NSDate *) aDate;

- (NSDate *) modificationDate;
- (void) setModificationDate:(NSDate *) aDate;

- (NSDate *) backupDate;
- (void) setBackupDate:(NSDate *) aDate;

- (NSArray *) records;
- (void) setRecords:(NSArray *) records;

+ palmPdbFromData:(NSData *)rawData;
- initFromData:(NSData *)rawData;
// - (NSData *) toData;

- (PdbRecord *) allocRecordForIdx:(int)n;
@end
